=== debian/changelog ===
ros-kinetic-opencv3 (3.3.1-5xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 15 Mar 2018 01:03:19 -0000
