=== debian/control ===
Source: ros-kinetic-opencv3
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libavcodec-dev, libavformat-dev, libavutil-dev, libjpeg-dev, libpng12-dev, libprotobuf-dev, libprotoc-dev, libswscale-dev, libtiff5-dev, libv4l-dev, libvtk6-qt-dev, libwebp-dev, protobuf-compiler, python-dev, python-numpy, zlib1g-dev
Homepage: http://opencv.org
Standards-Version: 3.9.2

Package: ros-kinetic-opencv3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libavcodec-dev, libavformat-dev, libavutil-dev, libjpeg-dev, libpng12-dev, libprotobuf9v5, libswscale-dev, libvtk6-qt-dev, libwebp-dev, python-dev, python-numpy, ros-kinetic-catkin, zlib1g-dev
Description: OpenCV 3.x
